var D=Object.create;var g=Object.defineProperty;var B=Object.getOwnPropertyDescriptor;var O=Object.getOwnPropertyNames;var H=Object.getPrototypeOf,L=Object.prototype.hasOwnProperty;var U=(e,t)=>{for(var a in t)g(e,a,{get:t[a],enumerable:!0})},j=(e,t,a,s)=>{if(t&&typeof t=="object"||typeof t=="function")for(let r of O(t))!L.call(e,r)&&r!==a&&g(e,r,{get:()=>t[r],enumerable:!(s=B(t,r))||s.enumerable});return e};var l=(e,t,a)=>(a=e!=null?D(H(e)):{},j(t||!e||!e.__esModule?g(a,"default",{value:e,enumerable:!0}):a,e)),z=e=>j(g({},"__esModule",{value:!0}),e);var rt={};U(rt,{StepResult:()=>h,createAgentTask:()=>S,default:()=>st,executeAgentTaskStep:()=>I,getAgentTask:()=>f,getAgentTaskStep:()=>q,listAgentTaskIDs:()=>v,listAgentTaskSteps:()=>w,v4:()=>N.v4});module.exports=z(rt);var k=require("uuid"),_=l(require("fs")),c=l(require("path"));var $=l(require("express-openapi-validator")),E=l(require("js-yaml")),o=l(require("express"));var A=`openapi: 3.0.1
info:
  title: Agent Protocol
  description: Specification of the API protocol for communication with an agent.
  version: v1
servers:
  - url: 'http://0.0.0.0:8000'
    description: Agent Protocol API
paths:
  /ap/v1/agent/tasks:
    post:
      operationId: createAgentTask
      summary: Creates a task for the agent.
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TaskRequestBody'
      responses:
        '200':
          description: A new agent task was successfully created.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Task'
          x-postman-variables:
            - type: save
              name: task_id
              path: .task_id
        '422':
          $ref: '#/components/responses/UnprocessableEntity'
        default:
          description: Internal Server Error
      tags:
        - agent
    get:
      operationId: listAgentTasks
      summary: List all tasks that have been created for the agent.
      parameters:
        - name: current_page
          in: query
          description: Page number
          required: false
          schema:
            type: integer
            format: int32
            default: 1
            minimum: 1
          example: 2
        - name: page_size
          in: query
          description: Number of items per page
          required: false
          schema:
            type: integer
            format: int32
            default: 10
            minimum: 1
          example: 25
      responses:
        '200':
          description: Returned list of agent's tasks.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TaskListResponse'
        default:
          description: Internal Server Error
      tags:
        - agent
  '/ap/v1/agent/tasks/{task_id}':
    get:
      operationId: getAgentTask
      summary: Get details about a specified agent task.
      parameters:
        - name: task_id
          in: path
          description: ID of the task
          required: true
          schema:
            type: string
          example: 1d5a533e-3904-4401-8a07-c49adf88b981
          x-postman-variables:
            - type: load
              name: task_id
      responses:
        '200':
          description: Returned details about an agent task.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Task'
        '404':
          $ref: '#/components/responses/NotFound'
        default:
          description: Internal Server Error
      tags:
        - agent
  '/ap/v1/agent/tasks/{task_id}/steps':
    get:
      operationId: listAgentTaskSteps
      summary: List all steps for the specified task.
      parameters:
        - name: task_id
          in: path
          description: ID of the task.
          required: true
          schema:
            type: string
          example: 50da533e-3904-4401-8a07-c49adf88b5eb
          x-postman-variables:
            - type: load
              name: task_id
        - name: current_page
          in: query
          description: Page number
          required: false
          schema:
            type: integer
            format: int32
            default: 1
            minimum: 1
          example: 2
        - name: page_size
          in: query
          description: Number of items per page
          required: false
          schema:
            type: integer
            format: int32
            default: 10
            minimum: 1
          example: 25
      responses:
        '200':
          description: Returned list of agent's steps for the specified task.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TaskStepsListResponse'
        '404':
          $ref: '#/components/responses/NotFound'
        default:
          description: Internal Server Error
      tags:
        - agent
    post:
      operationId: executeAgentTaskStep
      summary: Execute a step in the specified agent task.
      parameters:
        - name: task_id
          in: path
          description: ID of the task
          required: true
          schema:
            type: string
          example: 50da533e-3904-4401-8a07-c49adf88b5eb
          x-postman-variables:
            - type: load
              name: task_id
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/StepRequestBody'
      responses:
        '200':
          description: Executed step for the agent task.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Step'
          x-postman-variables:
            - type: save
              name: step_id
              path: .step_id
        '404':
          $ref: '#/components/responses/NotFound'
        '422':
          $ref: '#/components/responses/UnprocessableEntity'
        default:
          description: Internal Server Error
      tags:
        - agent
  '/ap/v1/agent/tasks/{task_id}/steps/{step_id}':
    get:
      operationId: getAgentTaskStep
      summary: Get details about a specified task step.
      parameters:
        - name: task_id
          in: path
          description: ID of the task
          required: true
          schema:
            type: string
          example: 50da533e-3904-4401-8a07-c49adf88b5eb
          x-postman-variables:
            - type: load
              name: task_id
            - type: load
              name: step_id
        - name: step_id
          in: path
          description: ID of the step
          required: true
          schema:
            type: string
          example: 28ca533e-3904-4401-8a07-c49adf8891c2
          x-postman-variables:
            - type: load
              name: step_id
      responses:
        '200':
          description: Returned details about an agent task step.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Step'
        '404':
          $ref: '#/components/responses/NotFound'
        default:
          description: Internal Server Error
      tags:
        - agent
  '/ap/v1/agent/tasks/{task_id}/artifacts':
    get:
      operationId: listAgentTaskArtifacts
      summary: List all artifacts that have been created for the given task.
      parameters:
        - name: task_id
          in: path
          description: ID of the task
          required: true
          schema:
            type: string
          example: 50da533e-3904-4401-8a07-c49adf88b5eb
          x-postman-variables:
            - type: load
              name: task_id
        - name: current_page
          in: query
          description: Page number
          required: false
          schema:
            type: integer
            format: int32
            default: 1
            minimum: 1
          example: 2
        - name: page_size
          in: query
          description: Number of items per page
          required: false
          schema:
            type: integer
            format: int32
            default: 10
            minimum: 1
          example: 25
      responses:
        '200':
          description: Returned the list of artifacts for the task.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TaskArtifactsListResponse'
        '404':
          $ref: '#/components/responses/NotFound'
        default:
          description: Internal Server Error
      tags:
        - agent
    post:
      operationId: uploadAgentTaskArtifacts
      summary: Upload an artifact for the specified task.
      parameters:
        - name: task_id
          in: path
          description: ID of the task
          required: true
          schema:
            type: string
          example: 50da533e-3904-4401-8a07-c49adf88b5eb
          x-postman-variables:
            - type: load
              name: task_id
      requestBody:
        content:
          multipart/form-data:
            schema:
              $ref: '#/components/schemas/ArtifactUpload'
      responses:
        '200':
          description: Returned the content of the artifact.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Artifact'
        '404':
          $ref: '#/components/responses/NotFound'
        default:
          description: Internal Server Error
      tags:
        - agent
  '/ap/v1/agent/tasks/{task_id}/artifacts/{artifact_id}':
    get:
      operationId: downloadAgentTaskArtifact
      summary: Download a specified artifact.
      parameters:
        - name: task_id
          in: path
          description: ID of the task
          required: true
          schema:
            type: string
          example: 50da533e-3904-4401-8a07-c49adf88b5eb
          x-postman-variables:
            - type: load
              name: task_id
        - name: artifact_id
          in: path
          description: ID of the artifact
          required: true
          schema:
            type: string
          example: 1e41533e-3904-4401-8a07-c49adf8893de
      responses:
        '200':
          description: Returned the content of the artifact.
          content:
            application/octet-stream:
              schema:
                type: string
                format: binary
        '404':
          $ref: '#/components/responses/NotFound'
        default:
          description: Internal Server Error
      tags:
        - agent
components:
  schemas:
    Pagination:
      type: object
      properties:
        total_items:
          description: Total number of items.
          type: integer
          example: 42
        total_pages:
          description: Total number of pages.
          type: integer
          example: 97
        current_page:
          description: Current_page page number.
          type: integer
          example: 1
        page_size:
          description: Number of items per page.
          type: integer
          example: 25
      required:
        - total_items
        - total_pages
        - current_page
        - page_size
    TaskListResponse:
      type: object
      properties:
        tasks:
          type: array
          items:
            $ref: '#/components/schemas/Task'
        pagination:
          $ref: '#/components/schemas/Pagination'
      required:
        - tasks
        - pagination
    TaskStepsListResponse:
      type: object
      properties:
        steps:
          type: array
          items:
            $ref: '#/components/schemas/Step'
        pagination:
          $ref: '#/components/schemas/Pagination'
      required:
        - steps
        - pagination
    TaskArtifactsListResponse:
      type: object
      properties:
        artifacts:
          type: array
          items:
            $ref: '#/components/schemas/Artifact'
        pagination:
          $ref: '#/components/schemas/Pagination'
      required:
        - artifacts
        - pagination
    TaskInput:
      description: Input parameters for the task. Any value is allowed.
      type: object
      example: |-
        {
        "debug": false,
        "mode": "benchmarks"
        }
    Artifact:
      description: An Artifact either created by or submitted to the agent.
      type: object
      properties:
        artifact_id:
          description: ID of the artifact.
          type: string
          example: b225e278-8b4c-4f99-a696-8facf19f0e56
        agent_created:
          description: Whether the artifact has been created by the agent.
          type: boolean
          example: false
        file_name:
          description: Filename of the artifact.
          type: string
          example: main.py
        relative_path:
          description: Relative path of the artifact in the agent's workspace.
          type: string
          example: python/code/
          nullable: true
      required:
        - artifact_id
        - agent_created
        - file_name
    ArtifactUpload:
      description: Artifact to upload to the agent.
      type: object
      properties:
        file:
          description: File to upload.
          type: string
          format: binary
          example: binary representation of file
        relative_path:
          description: Relative path of the artifact in the agent's workspace.
          type: string
          example: python/code
      required:
        - file
    StepInput:
      description: Input parameters for the task step. Any value is allowed.
      type: object
      example: |-
        {
        "file_to_refactor": "models.py"
        }
    StepOutput:
      description: Output that the task step has produced. Any value is allowed.
      type: object
      example: |-
        {
        "tokens": 7894,
        "estimated_cost": "0,24$"
        }
      nullable: true
    TaskRequestBody:
      description: Body of the task request.
      type: object
      properties:
        input:
          description: Input prompt for the task.
          type: string
          example: Write 'Washington' to the file 'output.txt'.
          nullable: true
        additional_input:
          $ref: '#/components/schemas/TaskInput'
    Task:
      allOf:
        - $ref: '#/components/schemas/TaskRequestBody'
        - type: object
          description: Definition of an agent task.
          required:
            - task_id
            - artifacts
          properties:
            task_id:
              description: The ID of the task.
              type: string
              example: 50da533e-3904-4401-8a07-c49adf88b5eb
            artifacts:
              description: A list of artifacts that the task has produced.
              type: array
              items:
                $ref: '#/components/schemas/Artifact'
              example:
                - 7a49f31c-f9c6-4346-a22c-e32bc5af4d8e
                - ab7b4091-2560-4692-a4fe-d831ea3ca7d6
              default: []
    StepRequestBody:
      description: Body of the task request.
      type: object
      properties:
        input:
          description: Input prompt for the step.
          type: string
          example: Write the words you receive to the file 'output.txt'.
          nullable: true
        additional_input:
          $ref: '#/components/schemas/StepInput'
    Step:
      allOf:
        - $ref: '#/components/schemas/StepRequestBody'
        - type: object
          required:
            - step_id
            - task_id
            - status
            - is_last
            - artifacts
          properties:
            task_id:
              description: The ID of the task this step belongs to.
              type: string
              example: 50da533e-3904-4401-8a07-c49adf88b5eb
            step_id:
              description: The ID of the task step.
              type: string
              example: 6bb1801a-fd80-45e8-899a-4dd723cc602e
            name:
              description: The name of the task step.
              type: string
              example: Write to file
              nullable: true
            status:
              description: The status of the task step.
              type: string
              example: created
              enum:
                - created
                - running
                - completed
            output:
              description: Output of the task step.
              type: string
              example: "I am going to use the write_to_file command and write Washington to a file called output.txt <write_to_file('output.txt', 'Washington')"
              nullable: true
            additional_output:
              $ref: '#/components/schemas/StepOutput'
            artifacts:
              description: A list of artifacts that the step has produced.
              type: array
              items:
                $ref: '#/components/schemas/Artifact'
              default: []
            is_last:
              description: Whether this is the last step in the task.
              type: boolean
              example: true
              default: false
  responses:
    UnprocessableEntity:
      description: Unable to process request. Likely due to improperly formatted request.
      content:
        application/json:
          schema:
            description: A generic JSON object without any specific requirements.
            type: object
    NotFound:
      description: Unable to find entity with a given identifier
      content:
        application/json:
          schema:
            type: object
            properties:
              message:
                description: Message stating the entity was not found
                type: string
                example: Unable to find entity with the provided id
            required:
              - message
`;var P=e=>{let t=(0,o.default)();t.use(o.default.json()),t.use(o.default.text()),t.use(o.default.urlencoded({extended:!1}));let a=E.default.load(A);t.use($.middleware({apiSpec:a,validateRequests:!0,validateResponses:!0})),t.get("/openapi.yaml",(r,n)=>{n.setHeader("Content-Type","text/yaml").status(200).send(A)});let s=(0,o.Router)();e.routes.forEach(r=>{r(s,e.context)}),t.use("/ap/v1",s),t.listen(e.port,e.callback)};var d=[],R=[],T=null,h=class{constructor(){this.output=null;this.artifacts=[];this.is_last=!1}},S=async e=>{if(T==null)throw new Error("Task handler not defined");let t={task_id:(0,k.v4)(),input:(e==null?void 0:e.input)??null,artifacts:[]},a=await T(t.task_id,(e==null?void 0:e.input)??null);return d.push([t,a]),t},G=e=>{e.post("/agent/tasks",(t,a)=>{(async()=>{try{let s=await S(t.body);a.status(200).json(s)}catch(s){console.error(s),a.status(500).json({error:s.message})}})()})},v=async()=>d.map(([e,t])=>e.task_id),M=e=>{e.get("/agent/tasks",(t,a)=>{(async()=>{try{let s=await v();a.status(200).json(s)}catch(s){console.error(s),a.status(500).json({error:s.message})}})()})},f=async e=>{let t=d.find(([a,s])=>a.task_id===e);if(t==null)throw new Error(`Task with id ${e} not found`);return t[0]},V=e=>{e.get("/agent/tasks/:task_id",(t,a)=>{(async()=>{try{let s=await f(t.params.task_id);a.status(200).json(s)}catch(s){console.error(s),a.status(500).json({error:s.message})}})()})},w=async e=>{if(d.find(([a,s])=>a.task_id===e)==null)throw new Error(`Task with id ${e} not found`);return R.filter(a=>a.task_id===e).map(a=>a.step_id)},J=e=>{e.get("/agent/tasks/:task_id/steps",(t,a)=>{(async()=>{try{let s=await w(t.params.task_id);a.status(200).json(s)}catch(s){console.error(s),a.status(500).json({error:s.message})}})()})},I=async(e,t)=>{let a=d.find(([i,p])=>i.task_id===e);if(a==null)throw new Error(`Task with id ${e} not found`);let s=a[1],r=await s((t==null?void 0:t.input)??null),n={task_id:e,step_id:(0,k.v4)(),input:(t==null?void 0:t.input)??null,name:r.name,output:r.output??null,artifacts:r.artifacts??[],is_last:r.is_last??!1,status:"completed"};return n.artifacts!=null&&n.artifacts.length>0&&(a[0].artifacts=a[0].artifacts??[],a[0].artifacts.push(...n.artifacts)),R.push(n),n},K=e=>{e.post("/agent/tasks/:task_id/steps",(t,a)=>{(async()=>{try{let s=await I(t.params.task_id,t.body);a.status(200).json(s)}catch(s){console.error(s),a.status(500).json({error:s.message})}})()})},q=async(e,t)=>{let a=R.find(s=>s.task_id===e&&s.step_id===t);if(a==null)throw new Error(`Step with task id ${e} and step id ${t} not found`);return a},Q=e=>{e.get("/agent/tasks/:task_id/steps/:step_id",(t,a)=>{(async()=>{try{let s=await q(t.params.task_id,t.params.step_id);a.status(200).json(s)}catch(s){console.error(s),a.status(500).json({error:s.message})}})()})},X=async e=>(await f(e)).artifacts,Y=e=>{e.get("/agent/tasks/:task_id/artifacts",(t,a)=>{(async()=>{let s=t.params.task_id;try{let r=await X(s);if(r===void 0)return a.status(404).json({error:`Task with id ${s} not found`});let n=1,i=10;t.query.current_page!==void 0&&!isNaN(Number(t.query.current_page))&&(n=Number(t.query.current_page)),t.query.page_size!==void 0&&!isNaN(Number(t.query.page_size))&&(i=Number(t.query.page_size));let p=r.length,x=Math.ceil(p/i),m=(n-1)*i,u=m+i,C=r.slice(m,u);a.status(200).send({artifacts:C,pagination:{total_items:p,total_pages:x,current_page:n,page_size:i}})}catch(r){console.error(r),a.status(404).json({error:r.message})}})()})},F=(e,t,a)=>{let s=c.isAbsolute(t)?t:c.join(process.cwd(),t);return c.join(s,e,a.relative_path??"",a.file_name)},Z=async(e,t,a,s)=>{let n={artifact_id:(0,k.v4)(),agent_created:!1,file_name:a.originalname,relative_path:s??null,created_at:Date.now().toString()};t.artifacts=t.artifacts!==null&&t.artifacts!==void 0?t.artifacts:[],t.artifacts.push(n);let i=F(t.task_id,e,n);return _.mkdirSync(c.join(i,".."),{recursive:!0}),_.writeFileSync(i,a.buffer),n},tt=(e,t)=>{e.post("/agent/tasks/:task_id/artifacts",(a,s)=>{(async()=>{try{let r=a.params.task_id,n=a.body.relative_path,i=d.find(([{task_id:u}])=>u===r);if(i===void 0)return s.status(404).json({message:"Unable to find task with the provided id"});let x=a.files.find(({fieldname:u})=>u==="file"),m=await Z(t.workspace,i[0],x,n);s.status(200).json(m)}catch(r){console.error(r),s.status(500).json({error:r.message})}})()})},et=async(e,t)=>{var r;let s=(r=(await f(e)).artifacts)==null?void 0:r.find(n=>n.artifact_id===t);if(s==null)throw new Error(`Artifact with id ${t} in task with id ${e} was not found`);return s},at=(e,t)=>{e.get("/agent/tasks/:task_id/artifacts/:artifact_id",(a,s)=>{(async()=>{let r=a.params.task_id,n=a.params.artifact_id;try{let i=await et(r,n),p=F(r,t.workspace,i);s.status(200).sendFile(p)}catch(i){console.error(i),s.status(404).json({error:i.message})}})()})},b={port:8e3,workspace:"./workspace"},y=class e{constructor(t,a){this.taskHandler=t;this.config=a}static handleTask(t,a){return T=t,new e(t,{workspace:a.workspace??b.workspace,port:a.port??b.port})}start(t){let a={port:t??this.config.port??b.port,routes:[G,M,V,J,K,Q,Y,tt,at],callback:()=>{console.log(`Agent listening at http://localhost:${this.config.port}`)},context:{workspace:this.config.workspace}};P(a)}};var N=require("uuid");var st=y;0&&(module.exports={StepResult,createAgentTask,executeAgentTaskStep,getAgentTask,getAgentTaskStep,listAgentTaskIDs,listAgentTaskSteps,v4});
//# sourceMappingURL=index.js.map